#include "sighand.h"   /* itime() */
#include "spins.h"

static FILE *ft=NULL, *fb=NULL;
/* nr=0,1,2,... -1=close, v2.20 less sys-calls, mpi_task 0 only */
/* write tridiagonal matrix elements ta[i-1] tb[i-1] i=1... */
void outtri(int nr, zahl a, zahl b){ 
//    static FILE *ft=NULL, *fb=NULL;
    long t=itime();
    int r0=0;
    if (nr<=0) {
      if (ft) fclose(ft); if (fb) fclose(fb); ft=fb=NULL; if (nr<0) return;
    }
    if (/* nr<=1 &&*/ !ft) {
      // 2012-05-10 JS add checkpoint 4
      // open if not open, truncate to 0 on start, append after chkpt.resume
      ft=fopen("tmp/tri.txt",((nr<=1)?"wt":"at"));
      fb=fopen("tmp/tri.dat",((nr<=1)?"wb":"ab"));
      if (ft) setvbuf(ft,NULL,_IONBF,0);
      if (fb) setvbuf(fb,NULL,_IONBF,0);
      if ((!ft) || (!fb)) { E0("fopen tmp/tri.{txt,dat}"); return; }
    }
    if (ft) fprintf(ft,"%3d %20.16f %20.16f %6.2fm\n",
                    nr, (double)a, (double)b, t/60.);
    if (fb)          r0=fwrite(&a,sizeof(zahl),1,fb); // ret=written_memb (1)
    if (fb && r0==1) r0=fwrite(&b,sizeof(zahl),1,fb);
    if (fb && r0!=1) E0("outtri write tri.dat");
    return;
}

/* restore tridiagonal matrix (zahl=double|ldouble?), n=MAX_ITR=dim */
int loadtri(zahl *a, zahl *b, int n){
    // FILE *fb; 
    int last=0;
    outtri(-1,0,0); /* close open tri-files */
    fb= fopen("tmp/tri.dat","rb");
    if (!fb) {E0("fopen(tmp/tri.dat)");return 0;}
    while (!feof(fb) || last>=n) {
      if (fread(a+last,sizeof(zahl),1,fb)!=1) break;
      if (fread(b+last,sizeof(zahl),1,fb)!=1) break;
      last++;
    }
    if (last  <n) { a[last  ]=0.0; b[last  ]=0.0; } // dbg fill ?
    if (last+1<n) { a[last+1]=0.0; b[last+1]=0.0; } // dbg fill ?
    fclose(fb); fb=NULL; /* do not close after checkpointing.resume?? */
    /* ToDo: call last times outtri */
    return last; /* number of loaded tri-diag tupel */
}

